#ryax-variable-list
  ng-container(*ngIf="variableList$ | async as variables")
    nz-spin([nzSpinning]="loading$ | async")
      nz-table([nzData]="variables", nzSize="middle", [nzOuterBordered]="true", [nzShowPagination]="true")
        thead
          tr
            th Name
            th Description
            th Type
            th Value
            th
        tbody
          tr(*ngFor="let variable of variables" )
            td.object-title
              code {{ variable.name }}
            td {{ variable.description }}
            td {{ variable.type }}
            td([ngSwitch]="variable.type")
              input(*ngSwitchDefault, nz-input, type="text", [value]="variable.value", disabled=true)
              textarea(*ngSwitchCase="'longstring'", nz-input, rows=4, [value]="variable.value", disabled=true)
              nz-input-group(*ngSwitchCase="'password'", [nzSuffix]="suffixTemplate")
                input(nz-input, [type]="passwordVisible ? 'text' : 'password'", [value]="variable.value", disabled=true)
              ng-template(#suffixTemplate)
                span(nz-icon, [nzType]="passwordVisible ? 'eye-invisible' : 'eye'", (click)="passwordVisible = !passwordVisible")
            td.actions
              button(nz-button, nzType="primary", nzGhost, nzSize="small", (click)="editOrAddVariable(variable)")
                i(nz-icon, nzType="edit", nzTheme="outline")
                span Edit
              button(
                nz-popconfirm=true,
                nzPopconfirmTitle="Are you sure delete this variable?",
                nzPopconfirmPlacement="bottom",
                (nzOnConfirm)="deleteVariable(variable)",
                nz-button, nzSize="small", nzDanger
              )
                i(nz-icon, nzType="delete", nzTheme="outline")
                span Delete

button(nz-button, nzType="primary", (click)="editOrAddVariable(null)") Add a Variable

nz-modal([(nzVisible)]="openEditModal", nzTitle="Edit variable", [nzWidth]="600", (nzOnCancel)="handleCancel()", (nzOnOk)="handleOk()", [nzOkDisabled]="!this.form.valid")
  ng-container(*nzModalContent)
    form(nz-form, [formGroup]="form", [nzLayout]="'vertical'")
      //nz-form-item
      //  nz-form-label Name
      //  nz-form-control(nzHasFeedback, nzErrorTip="name must be defined")
      //    input(type="text", nz-input, name="name", placeholder="Variable name", formControlName="name", required)
      nz-form-item
        nz-form-label Name
        nz-form-control(nzHasFeedback, nzErrorTip="name must not contain space or special characters")
          input(type="text", nz-input, name="variable name", placeholder="Name of the variable in your code", formControlName="name", required)
      nz-form-item
        nz-form-label Description
        textarea(nz-input, name="variable description", placeholder="What your variable is for", formControlName="description")
      nz-form-item(*ngIf="isCreation")
        nz-form-label Type
        nz-form-control(nzHasFeedback, nzErrorTip="type must be defined")
          nz-select(formControlName="type", nzPlaceHolder="Type", required)
            nz-option(*ngFor="let type of outputTypes", [nzValue]="type", [nzLabel]="type")

      nz-form-item(*ngIf="!isCreation")
        nz-form-label Type
        nz-form-control(nzHasFeedback)
          input(nz-input, type="text",[value]="getType()", disabled=true)
          p Type cannot be changed once created
      nz-form-item
        nz-form-label Value
        nz-form-control([ngSwitch]="getType()", nzHasFeedback, nzErrorTip="value must be defined")
          input(*ngSwitchCase="'string'", nz-input, type="text", formControlName="value")
          nz-input-group(*ngSwitchCase="'password'", [nzSuffix]="suffixTemplate")
            input(nz-input, [type]="passwordVisible ? 'text' : 'password'", formControlName="value")
          ng-template(#suffixTemplate)
            span(nz-icon, [nzType]="passwordVisible ? 'eye-invisible' : 'eye'",(click)="passwordVisible = !passwordVisible")

          nz-input-number(*ngSwitchCase="'integer'", formControlName="value")
          nz-input-number(*ngSwitchCase="'float'", formControlName="value")
          textarea(*ngSwitchCase="'longstring'", rows="4", nz-input, formControlName="value")
          input(*ngSwitchCase="'boolean'", type="checkbox", nz-input, formControlName="value")
          p(*ngSwitchDefault) Please select a Type.
          div(*ngSwitchCase="'file'")
            ryax-upload(id="file", formControlName="value", listType="picture-card")
          div(*ngSwitchCase="'directory'")
            ryax-upload(id="directory", formControlName="value", listType="picture-card", [nzDirectory]="true")


